package hu.bme.mit.bookmanager.ui;

import hu.bme.mit.bookmanager.IBookManager;

import java.util.ArrayList;
import java.util.Collection;

public class BookServiceAccessor {

	public interface IServiceListener {
		void serviceBound(IBookManager manager);
		void serviceUnbound();
	}
	
	public static class ServiceManager {

		public Collection<IServiceListener> listeners = new ArrayList<BookServiceAccessor.IServiceListener>();
		IBookManager manager;
		
		public void addServiceListener(IServiceListener listener) {
			listeners.add(listener);
		}
		
		public void removeServiceListener(IServiceListener listener) {
			listeners.remove(listener);
		}
		
		public IBookManager getBookManager() {
			return manager;
		}
	}

	private static ServiceManager INSTANCE = new ServiceManager();
	
	public static ServiceManager getInstance() {
		return INSTANCE;
	}

	
	public void bindManager(IBookManager manager) {
		INSTANCE.manager = manager;
		for (IServiceListener listener : INSTANCE.listeners) {
			listener.serviceBound(manager);
		}
	}
	
	public void unbindManager(IBookManager manager) {
		for (IServiceListener listener : INSTANCE.listeners) {
			listener.serviceUnbound();
		}
		INSTANCE.manager = null;
	}

}
