package hu.bme.mit.bookmanager;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class BookManager implements IBookManager {

	private List<Book> bookList = new ArrayList<Book>();
	
	public BookManager() {
		addBook(new Book(
				"Terry Pratchett", "The Light Fantastic",
				512, false));
		addBook(new Book("Neil Gaiman", "Anansi Boys", 525, true));
		addBook(new Book("Terry Pratchett", "The Color of Magic",
				 300, false));
		addBook(new Book("Neil Gaiman", "American Gods", 
				700, true));
		addBook(new Book("Steven Erikson", "Memories of Ice", 1200, false));
		addBook(new Book("Steven Erikson", "Deadhouse Gates", 900, true));
	}
	
	/* (non-Javadoc)
	 * @see hu.bme.mit.bookmanager.IBookManager#addBook(hu.bme.mit.bookmanager.Book)
	 */
	@Override
	public void addBook(Book book) {
		bookList.add(book);
	}
	
	/* (non-Javadoc)
	 * @see hu.bme.mit.bookmanager.IBookManager#removeBook(hu.bme.mit.bookmanager.Book)
	 */
	@Override
	public void removeBook(Book book) {
		bookList.remove(book);
	}
	
	/* (non-Javadoc)
	 * @see hu.bme.mit.bookmanager.IBookManager#getAllBooks()
	 */
	@Override
	public List<Book> getAllBooks() {
		return Collections.unmodifiableList(bookList);
	}
	
	/* (non-Javadoc)
	 * @see hu.bme.mit.bookmanager.IBookManager#getAllBooksOfAuthor(java.lang.String)
	 */
	@Override
	public List<Book> getAllBooksOfAuthor(String author) {
		if (author == null) {
			throw new IllegalArgumentException("Author name cannot be null");
		}
		List<Book> filteredList = new ArrayList<Book>();
		for (Book book : bookList) {
			if (author.equals(book.getAuthor())) {
				filteredList.add(book);
			}
		}
		return filteredList;
	}
}
